/*
 * Плагин jQuery.
 * Создает обработчики для каждой записи в таблице.
 */ 
(function($) {
	$.fn.todonote = function(options) {
		var settings = $.extend({
			updateDialogId: 'updatenote'
			, removeDialogId: 'removenote'
		}, options || {});
		var element = this;
		
		var updateLink = element.find('a.updateNote');
		var updateNoteTrigger = updateLink.overlay({
			expose: {
				color: '#333'
				, loadSpeed: 100
				, opacity: 0.5
			}
			, closeOnClick: false
		});
		
		/*
		 * Этот обработчик устанавливает текущее состояние записи в диалоге "Изменить"
		 */
		updateLink.bind('click', function(e) {
			var curTr = $(this).parent().parent();
			var elementId = curTr.attr('id').substring(5);
			var eState = curTr.find('img.note_state');
			var elementStateImg = eState.attr('src');
			var elementState = eState.attr('alt');
			
			$.todo.curNote = elementId;
			$.todo.curTrigger = $(this);
			
			//вставляем картинку с текущим состоянием и его описание
			$('#updateNoteState').html('<img src="' + elementStateImg
				+ '" alt="' + elementState + '" /><span>'
				+ $.todo.states[elementState] + '</span>');
			//заполняем поля "Текст" и "Дата"
			$("#updateNoteText").val(curTr.find("pre").html());
			$("#updateNoteDate").val(curTr.find(".note_date").html());
		});
		
		/*
		 * Подключаем диалог удаления записи
		 */
		var removeLink = element.find('a.removeNote');
		var removeNoteTrigger = removeLink.overlay({
			expose: {
				color: '#333'
				, loadSpeed: 100
				, opacity: 0.5
			}
			, closeOnClick: false
		}).click(function(e) {
			var curTr = $(this).parent().parent();
			var elementId = curTr.attr('id').substring(5);

			$.todo.curNote = elementId;
			$.todo.curTrigger = $(this);
		});
		
		return element;
	};
})(jQuery);