/*
 * Начальная настройка приложения.
 */
$(function() {
	//создаём глобальный объект для хранения данных приложения
	$.todo = new Object();
	
	$.todo.states = {
        'NEW' : $.td.tdlNew
        ,'START' : $.td.tdlStart
        ,'HALF' : $.td.tdlHalf
        ,'DONE' : $.td.tdlDone
        ,'CANCELED' : $.td.tdlCanceled
        ,'DELEGATED' : $.td.tdlDelegated
        ,'IMPORTANT' : $.td.tdlImportant
        ,'ATTENTION' : $.td.tdlAttention
	};

	//настраиваем и подключаем календарь
	
	//эта часть общая для всего приложения
	$.dpText = {
		TEXT_PREV_YEAR		:	$.td.tdlPrevYear,
		TEXT_PREV_MONTH		:	$.td.tdlPrevMonth,
		TEXT_NEXT_YEAR		:	$.td.tdlNextYear,
		TEXT_NEXT_MONTH		:	$.td.tdlNextMonth,
		TEXT_CLOSE			:	$.td.tdlClose,
		TEXT_CHOOSE_DATE	:	$.td.tdlSelectDate
	}
	Date.firstDayOfWeek = 1;
	Date.format = 'yyyy-mm-dd';

	var calendar = $('input[name=notedate]').datePicker({clickInput:true, startDate:'1996-01-01'});
	calendar.dpSetPosition($.dpConst.POS_TOP, $.dpConst.POS_RIGHT);
	//сдвигаем календарь под поле ввода
	calendar.dpSetOffset(22, 2);

	//подключаем подсказки
	$('#newNoteText, #newNoteDate')
		.tooltip({
			tip: '#newnotetip'
			, position: 'center right'
			, offset: [0, 20]
		});

	$('#updateNoteText, #updateNoteDate')
		.tooltip({
			tip: '#updatenotetip'
			, position: 'center right'
			, offset: [0, 20]
		});
		
    /**
     * Это общая функция для форм добавления и обновления записей.
     * Проверяет введенные значения и показывает подсказки, если они
     * установлены.
     */
    $.todo.checkFields = function(dialogId) {
    	var nt = $('#' + dialogId + ' form p textarea[name=notetext]');
    	var nd = $('#' + dialogId + ' form p input[name=notedate]');
    	nt.removeClass('.field_error');
    	nd.removeClass('.field_error');
    	var result = true;
        if ((nt.val().length > 4000 || nt.val().length < 1)) {
        	//показываем подсказку и подсвечиваем поле
        	nt.tooltip(0).show();
        	nt.addClass('field_error');
            result = false;
        }
        if (!(/\d{4}-\d{2}-\d{2}/.test(nd.val()))) {
        	//показываем подсказку и подсвечиваем поле
        	nd.tooltip(0).show();
        	nd.addClass('field_error');
            result = false;
        }
    	return result;
    }


	/*
	 * Подключаем наш плагин (jquery.todonote.js), который создает обработчики для записей таблицы
	 */
	$('#noteslist tr').todonote({});
});